<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" >
      <el-form-item label="路线名称：" prop="name">
        <el-input
          v-model.trim="queryParams.name"
          placeholder="请输入路线名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item class="right">
        <el-button plain size="mini" @click="resetQuery">重置</el-button>
        <el-button type="primary" size="mini" @click="handleQuery">搜索</el-button>
      </el-form-item>
      <br>
        <el-button
         type="primary"
          size="mini"
          @click="handleAdd"
        >新增</el-button>
    </el-form>
    <el-table v-loading="loading" :data="adminList" style="margin-top:20px;" border>
      <el-table-column label="路线名称" align="center" prop="name"  show-overflow-tooltip />
      <el-table-column label="创建时间" align="center" prop="createTime"  show-overflow-tooltip />
      <el-table-column label="创建人" align="center" prop="createBy"  show-overflow-tooltip />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" >
        <template slot-scope="scope">
          <el-button
            size="mini"
            class="lans"
            @click="handleUpdate(scope.row)"
          >修改</el-button>
          <el-button
            size="mini"
            class="lans"
            @click="handleDelete(scope.row)"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <!-- 修改、新增对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="600px" append-to-body :before-close="cancel" :close-on-click-modal="false">
      <el-form ref="form" :model="form" :rules="rules" label-width="auto" >
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="路线名称" prop="name">
              <el-input v-model="form.name" placeholder="请填写路线名称" @input="onInput()" maxlength="15" show-word-limit />
            </el-form-item>
          </el-col>
          <el-col style="font-size:16px;font-weight:700;margin:10px 0 20px;">维保点位</el-col>
          <el-table v-loading="loading2" :data="adminList2" height="200" @selection-change="handleSelectionChange"  ref="dataTable" style="margin-bottom:50px">
            <el-table-column type="selection" />
            <el-table-column label="点位名称" align="center" prop="name"  show-overflow-tooltip />
            <el-table-column label="点位地址" align="center" prop="address"  show-overflow-tooltip />
          </el-table>
           <el-pagination
           style="bottom:0px"
            background
            @current-change="handleCurrentChange2"
            :page-sizes="[10, 15, 20, 30]"
            @size-change="handleSizeChange2"
            :current-page="queryParams2.pageNo"
            :page-size="queryParams2.pageSize"
            layout="sizes,prev, pager, next"
            :total="totalCount2"
          >
          </el-pagination>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel" plain>取 消</el-button>
      </div>
    </el-dialog>
    <el-pagination
      background
      @current-change="handleCurrentChange1"
      :page-sizes="[10, 15, 20, 30]"
      @size-change="handleSizeChange1"
      :current-page="queryParams.pageNo"
      :page-size="queryParams.pageSize"
      layout="sizes,prev, pager, next"
      :total="totalCount1"
    >
    </el-pagination>
    <a href="" download="" id="xz" style="position: absolute;z-index: -1;opacity: 0;"></a>
  </div>
</template>
<script>
import { getInspectionPoint } from "@/api/MochaITOM/point";
import { addPlanPath, delPlanPath, updatePlanPath, getPlanPath, getXL } from "@/api/MochaITOM/route";
export default {
  name: "Floor",
  data() {
    return {
      loading:true,
      loading2:true,
      exportLoading:false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      totalCount1: undefined,
      // 总条数
      totalCount2: undefined,
      // 参数表格数据
      adminList: [],
      // 参数表格数据
      adminList2: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        current: 1,
        size: 15,
        name: undefined,
        dutyId:undefined,
        pageNo:1,
        pageSize:15,
      },
      // 查询参数
      queryParams2: {
        current: 1,
        size: 15,
        pageNo:1,
        pageSize:15,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        name: [
          { required: true, message: "线路名称不能为空",  trigger: "blur"  }
        ],
      },
    };
  },
  created() {
    this.getList();//初始化table
  },
  methods: {
    //分页查询
    handleCurrentChange1(val) {
      this.queryParams.pageNo = val;
      this.getList();
    },
    //分页查询
    handleSizeChange1(val) {
      this.queryParams.pageSize = val;
      this.getList();
    },
    //分页查询
    handleCurrentChange2(val) {
      this.queryParams2.pageNo = val;
      this.getList();
    },
    //分页查询
    handleSizeChange2(val) {
      this.queryParams2.pageSize = val;
      this.getList();
    },
    //强制el-input刷新
    onInput(){
        this.$forceUpdate();
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.queryParams = {
        name:undefined,
        current:1,
        size:15,
        pageSize:15,
        pageNo:1,
      }
      this.handleQuery();
    },
    // 表单重置
    reset() {
      this.form = {};
      // this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.current = 1;
      this.getList();
    },
    /** 查询参数列表 */
    getList() {
      this.loading = true;
      getPlanPath(this.queryParams).then(response => {
        this.adminList = response.data.pageList;
        this.totalCount1 = response.data.totalCount;
        this.loading = false;
      });
    },
    getList2(row){
        this.adminList2 = []
        getInspectionPoint(this.queryParams2).then(response => {
            this.adminList2 = response.data.pageList;
            this.totalCount2 = response.data.totalCount;
            if(row && row.pointIds.length>0){
                let list = []
                for(let a = 0;a<row.pointIds.length;a++){
                    for(let i = 0; i<this.adminList2.length;i++){
                        if(row.pointIds[a] == this.adminList2[i].id){
                            list.push(this.adminList2[i])
                        }
                    }
                }
                setTimeout(() => {
                    var that = this;
                    that.$nextTick(() => {
                        if(list){
                            list.forEach((row) => {
                                that.$refs.dataTable.toggleRowSelection(row, true)
                            })
                        }
                    })
                    this.total2 = response.data.total;
                    this.loading2 = false;
                })
            }else{
                this.total2 = response.data.total;
                this.loading2 = false;
            }
        });
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      this.title = "修改";
      this.form = JSON.parse(JSON.stringify(row))
      getXL({pathId:row.id}).then(res =>{
          if(res.data.length>0){
              row.pointIds = []
              for(let i=0;i<res.data.length;i++){
                  row.pointIds.push(res.data[i].pointId)
              }
          }
          this.getList2(row)
          this.open = true;
      })
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.getList2()
      this.open = true;
      this.title = "新增";
    },
    /** 提交按钮 */
    submitForm(row) {
      this.form.userIds = []
      this.form.userIds = this.list
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.loading = true
          if (this.form.id != undefined) {
            updatePlanPath(this.form).then(response => {
              this.loading = false,
              this.$message.success("修改成功");
              this.open = false;
              this.getList();
            }).catch(()=>{
              this.loading = false
            })
          } else {
            addPlanPath(this.form).then(response => {
              this.loading = false
              if(response.status == "SUCCESS"){
                this.$message.success("新增成功");
                this.open = false;
                this.getList();
              }
            })
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delPlanPath(ids);
        }).then(() => {
          this.getList();
          this.$message.success("删除成功");
        }).catch(() => {});
    },
    /** table */
    handleSelectionChange(row){
        this.form.pointIds = []
        for(let i=0;i<row.length;i++){
            this.form.pointIds.push(row[i].id)
        }
    }
  }
};
</script>
